#ifndef __GROUNDED_SEMANTIC_PROBLEM_SOLVER_H__
#define __GROUNDED_SEMANTIC_PROBLEM_SOLVER_H__


#include "CompleteSemanticProblemSolver.h"


using namespace std;


/** 
 * \class GroundedSemanticProblemSolver
 * \brief a minisat based solver for grounded semantic tasks
 */
class GroundedSemanticProblemSolver : public CompleteSemanticProblemSolver {
  
 public :
  
  /**
   * \fn GroundedSemanticProblemSolver(TaskType,string)
   * \brief initialize the problem solver given a task
   * \param task : the task (SE, EE, DC, DS) that is asked
   * \param additionalParams the additional parameters from the command line
   */
  GroundedSemanticProblemSolver(TaskType task, map<string,string> *additionalParams);


  /**
   * \fn ~GroundedSemanticProblemSolver
   * \brief destructor
   */
  ~GroundedSemanticProblemSolver();

  virtual void computeProblem();
  void computeOneExtension(vector<int> *assumps, bool resultIsModel);
  void computeAllExtensions(vector<int> *assumps);

private:
  string trailToStringExtension();
};


#endif
