#include "StableSemanticProblemSolver.h"



using namespace std;


StableSemanticProblemSolver::StableSemanticProblemSolver(TaskType task, map<string,string> *additionalParams) : DefaultSatBasedSolver(task, additionalParams) {}

StableSemanticProblemSolver::~StableSemanticProblemSolver() {}


void StableSemanticProblemSolver::initProblem(Attacks *attacks, VarMap *varMap){
  this->varMap = varMap;
  this->attacks = attacks ;
  vector<int> *vars = varMap->intVars();
  nbArgs = vars->size();
  for(unsigned int i=0; i<vars->size(); solver.newVar(), ++i); // init solver vars
  vector<int> *attacksToCurrentVar;
  Minisat::vec<Minisat::Lit> binaryClause, completeClause;
  for(vector<int>::iterator itVars = vars->begin(); itVars != vars->end(); ++itVars) { // iterate over vars
      completeClause.push(Minisat::mkLit(*itVars-1));
      attacksToCurrentVar = attacks->getAttacksTo(*itVars);
      if(attacksToCurrentVar->size() == 0) {
	solver.addClause_(completeClause, true);
	completeClause.clear();
	continue;
      }
      for(vector<int>::iterator itAttackers = attacksToCurrentVar->begin(); itAttackers != attacksToCurrentVar->end(); ++itAttackers) {
	binaryClause.push(~Minisat::mkLit(*itVars-1));
	binaryClause.push(~Minisat::mkLit(*itAttackers-1));
	solver.addClause_(binaryClause, true);
	binaryClause.clear();
	completeClause.push(Minisat::mkLit(*itAttackers-1));
      }
      solver.addClause_(completeClause, true);
      completeClause.clear();
    }
  delete vars;
  solver.useAsCompleteSolver();
}
